program Priklad5;

type tIndex = (iUhel, iUhlovaRychlost);
     tPole = array[tIndex] of real;
     tProc = procedure( var dUdt : tPole; const U : tPole);

procedure EulerStep( Spocti_dUdt : tProc ; var U : tPole; var  t : real; const dt : real);
var    i : tIndex;
    dUdt : tPole;
begin
 Spocti_dUdt(dUdt,U);
 for i:=Low(U) to High(U) do U[i] := U[i] + dUdt[i]*dt;
 t := t+dt;
end;

procedure PohyboveRovniceKyvadla( var dVdt : tPole; const V : tPole);
begin
    dVdt[iUhel]           :=  V[iUhlovaRychlost];
    dVdt[iUhlovaRychlost] := -sin(V[iUhel]);
end;

const dt=0.001;

var  t : real = 0;        // pocatecni cas
     V : tPole = (3.1,0); // pocatecni podminky jako inicializovana promenna
     n : integer = 0;

begin

  while (t<20) do begin
    if n mod 100 = 0 then writeln(t,' ',V[iUhel]);
    EulerStep(PohyboveRovniceKyvadla,V,t,dt);
    n   := n+1;
  end;

end.
